var icms = icms || {};

icms.grades = (function ($) {

    this.options = {}

    this.setOptions = function(options){
        this.options = options;
    }

    //====================================================================//
    this.onDocumentReady = function () {

        $('.rate').each(function(){

			var widget = $(this);

            var controller = widget.data('target-controller');
            var subject = widget.data('target-subject');
            var id = widget.data('target-id');
            var url = widget.data('info-url');
        	var voteurl = widget.data('vote-url');
			
        $(".grades_widget").hover(
                function () { $(this).append("<span></span>"); },
                function () { $(this).find("span").remove();} 
        );


        var grades;

        $(".grades_widget").mousemove(
                /*
                 устанавливаем ширину блока с подсветкой таким образом, чтобы была выделена оценка, находящаяся под курсором мыши
                 */
                        function (e) {
                            if (!e)
                                e = window.event;
                            if (e.pageX) {
                                x = e.pageX;
                            } else if (e.clientX) {
                                x = e.clientX + (document.documentElement.scrollLeft || document.body.scrollLeft) - document.documentElement.clientLeft;

                            }
                            var posLeft = 0;
                            var obj = this;
                            while (obj.offsetParent)
                            {
                                posLeft += obj.offsetLeft;
                                obj = obj.offsetParent;
                            }
                            var offsetX = x - posLeft,
                                    modOffsetX = 100 * offsetX % this.offsetWidth; /* 5 - число возможных оценок */
                            grades = parseInt(100 * offsetX / this.offsetWidth);

                            if (modOffsetX > 0)
                                grades += 1;
							
                            $(this).find("span").eq(0).css("width", grades * 1 + "px"); /* ширина одной оценки, в данном случае одной звезды */

                        });
	

                $(".grades_widget", widget).click(
				function (){
                   icms.grades.vote(grades, controller, subject, id, voteurl);
                          /* alert("Я ставлю " + grades + controller + subject + id);*/
                        });						
						
										
			$('.grades_score span.clickable').click( function(){
                icms.modal.openAjax(url, {
                   controller: controller,
                   subject: subject,
                   id: id
                });
            });			
            
              });
          }      
    //====================================================================//

    this.vote = function (direction, controller, subject, id, voteurl) {
		
        var widget_id = 'grades-' + subject + '-' + id;
        var widget = $('#' + widget_id);
		var percent = $('.result_grade').get(0).outerHTML;
		
        $('.result_grade', widget).html('<div class="loading-icon"></div>');
		
        $.post(voteurl, {
            direction: direction,
            controller: controller,
            subject: subject,
            id: id

        }, function (result) {

            if (!result.success) {
				$('.result_grade', widget).html(percent);
                $('.grades_title', widget).html('Вы уже голосовали.');
				
                return;
            } 
			
            $('.vote-up', widget).css("width", result.grades + "%");
			$('.grades_widget', widget).toggleClass('grades_widget_disabled');
            $('.grades_widget', widget).removeClass('grades_widget');
            $('.result_grade', widget).html(result.grades + '/100');
			$('.grades_title', widget).html('Ваш голос принят.');
			
            /*$('.grades_widget', widget).attr('title', result.message);*/
			if (result.grades < 30) { $('.vote-up', widget).attr('id', 'red_scale'); }
			if (result.grades > 30) { $('.vote-up', widget).attr('id', 'yellow_scale'); }
			if (result.grades > 60) { $('.vote-up', widget).attr('id', 'green_scale'); }
			if (result.grades < 40) {
            $('.grades_info').html('<span class="negative clickable"><strong>Вы сочли страницу неинформативной.</strong><br/>Если вас не затруднит укажите в комментариях почему. Это поможет нам сделать ее полезнее.</span>');
			}
			
        }, "json");

    }

    //====================================================================//

    this.bingInfoPages = function () {

        var widget = $('.grades_info_pagination');

        var controller = widget.data('target-controller');
        var subject = widget.data('target-subject');
        var id = widget.data('target-id');
        var url = widget.data('url');

        $('.result_grade', widget).click(function () {

            var link = $(this);
            var page = link.data('page');
            var list = $('#grades_info_window:visible .grades_info_list');

            $('a', widget).removeClass('active');
            link.addClass('active');

            list.addClass('loading-panel');

            $.post(url, {
                controller: controller,
                subject: subject,
                id: id,
                page: page,
                is_list_only: true

            }, function (result) {

                list.html(result).removeClass('loading-panel');

            }, "html");

            return false;

        });

    }

    //====================================================================//
    //====================================================================//

    return this;

}).call(icms.grades || {}, jQuery);